"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BuerliPluginsGeometry = void 0;
const react_1 = __importDefault(require("react"));
const PluginWrapperView_1 = require("./plugins/PluginWrapperView");
const usePluginIds_1 = require("./plugins/usePluginIds");
const hooks_1 = require("../hooks");
/**
 * Renders the wrappers for all available plugins.
 *
 * Because of performance reasons, this is done in
 * this component and not directly in the canvas!
 */
exports.BuerliPluginsGeometry = react_1.default.memo(props => {
    const { drawingId, showOnlyActive = true } = props;
    const activeDrawingId = (0, hooks_1.useBuerli)(state => state.drawing.active);
    const actualDrawingId = drawingId !== null && drawingId !== void 0 ? drawingId : activeDrawingId;
    const pluginIds = (0, usePluginIds_1.usePluginIds)(actualDrawingId);
    return (react_1.default.createElement(react_1.default.Fragment, null, pluginIds === null || pluginIds === void 0 ? void 0 : pluginIds.map(plugId => (react_1.default.createElement(PluginWrapperView_1.PluginWrapperView, { key: plugId, drawingId: actualDrawingId, pluginId: plugId, showOnlyActive: showOnlyActive })))));
});
