"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.View = void 0;
const core_1 = require("@buerli.io/core");
const react_1 = __importStar(require("react"));
const react_spring_1 = require("react-spring");
const usePluginExists_1 = require("../hooks/usePluginExists");
const styled_components_1 = __importDefault(require("styled-components"));
const THREE = __importStar(require("three"));
const useDrawing_1 = require("../hooks/useDrawing");
const usePlugin_1 = require("../hooks/usePlugin");
function Root({ drawingId, pluginId }) {
    const PluginRoot = (0, usePlugin_1.usePlugin)(drawingId, pluginId, plugin => plugin.Root);
    const result = PluginRoot ? (react_1.default.createElement(Container, null,
        react_1.default.createElement(PluginRoot, { drawingId: drawingId, pluginId: pluginId }))) : null;
    const transitions = (0, react_spring_1.useTransition)(result, null, {
        from: { opacity: 0, transform: 'translate3d(0,20px,0)' },
        enter: { opacity: 1, transform: 'translate3d(0,0px,0)' },
        leave: { opacity: 0, transform: 'translate3d(0,20px,0)' },
    });
    return (react_1.default.createElement(react_1.default.Fragment, null, transitions.map(({ item, props, key }) => (react_1.default.createElement(react_spring_1.animated.div, { key: key, style: props, children: item })))));
}
function View({ drawingId, pluginId, additionalProps = {}, }) {
    const objectId = (0, usePlugin_1.usePlugin)(drawingId, pluginId, state => state.objectId) || -1;
    const isGlobal = (0, usePlugin_1.usePlugin)(drawingId, pluginId, state => state.global);
    // Selector of useDrawing below might be called after removing object with objectId from tree
    // Thus we need to check whether the object exists in tree or not before getting coordinateSystem
    const csys = (0, useDrawing_1.useDrawing)(drawingId, drawing => { var _a; return objectId >= 0 && ((_a = drawing.structure.tree[objectId]) === null || _a === void 0 ? void 0 : _a.coordinateSystem); });
    const transformMatrix = (0, react_1.useMemo)(() => (csys ? core_1.MathUtils.convertToMatrix4(csys) : new THREE.Matrix4()), [csys]);
    // CAD-3022.
    // When feature object has been just deleted corresponding plugin still exists for a while
    // Thus this component will be rendered for unexisting object. In this case it shoud return null
    const objectExists = (0, useDrawing_1.useDrawing)(drawingId, d => d.structure.tree[objectId] !== undefined);
    const PluginView = (0, usePlugin_1.usePlugin)(drawingId, pluginId, plugin => plugin.View);
    if (!PluginView)
        return null;
    if (!objectExists && !isGlobal)
        return null;
    return (react_1.default.createElement("group", { matrix: transformMatrix, matrixAutoUpdate: false },
        react_1.default.createElement(PluginView, Object.assign({ drawingId: drawingId, pluginId: pluginId }, additionalProps))));
}
exports.View = View;
function Plugin({ view, drawingId, pluginId, }) {
    // Feature plugins are lazy loaded, so it's possible that rendered plugin hasn't been created yet
    const isCreated = (0, usePluginExists_1.usePluginExists)(drawingId, pluginId);
    const Type = view ? View : Root;
    return isCreated ? react_1.default.createElement(Type, { key: pluginId, pluginId: pluginId, drawingId: drawingId }) : null;
}
exports.default = Plugin;
const Container = styled_components_1.default.div `
  width: 100%;
  color: rgba(0, 0, 0, 0.75);
  display: flex;
  flex-direction: column;
`;
