"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Product = void 0;
const core_1 = require("@buerli.io/core");
const deepmerge = __importStar(require("deepmerge"));
const react_1 = __importDefault(require("react"));
const hooks_1 = require("../hooks");
const geometry_1 = require("./geometry");
const GlobalTransform_1 = require("./GlobalTransform");
// TODO: Make GlobalTransform optional, by default true
const Solid = ({ drawingId, solidId, productId, }) => {
    var _a, _b;
    const globalConfig = (0, hooks_1.useBuerli)(buerli => buerli.options.config.geometry);
    const geometry = (0, hooks_1.useDrawing)(drawingId, drawing => drawing.geometry.cache[solidId]);
    const productConfig = (0, hooks_1.useDrawing)(drawingId, drawing => drawing.geometry.config.product[productId]);
    const solidConfig = (0, hooks_1.useDrawing)(drawingId, drawing => drawing.geometry.config.product[solidId]);
    const config = react_1.default.useMemo(() => {
        return deepmerge.all([globalConfig, productConfig || {}, solidConfig || {}]);
    }, [globalConfig, productConfig, solidConfig]);
    const ownerId = (_b = (_a = geometry === null || geometry === void 0 ? void 0 : geometry.container) === null || _a === void 0 ? void 0 : _a.ownerId) !== null && _b !== void 0 ? _b : core_1.NOID;
    const ownerName = (0, hooks_1.useDrawing)(drawingId, drawing => { var _a; return (_a = drawing.structure.tree[ownerId]) === null || _a === void 0 ? void 0 : _a.name; });
    return geometry && geometry.type === core_1.GraphicType.BREP ? (react_1.default.createElement("group", { name: ownerName, userData: { id: ownerId } },
        react_1.default.createElement("group", { name: `${solidId}`, userData: { id: solidId } },
            react_1.default.createElement(geometry_1.Geometry, { key: geometry.dirtyStamp || -1, drawingId: drawingId, containerId: solidId, productId: productId, geometry: geometry, config: config })))) : null;
};
const Part = ({ drawingId, partId, productId, }) => {
    const part = (0, hooks_1.useDrawing)(drawingId, state => state.structure.tree[partId]);
    return part ? (react_1.default.createElement("group", { name: part.name, userData: { id: part.id } }, Array.isArray(part.solids)
        ? part.solids.map(id => react_1.default.createElement(Solid, { key: id, productId: productId, solidId: id, drawingId: drawingId }))
        : null)) : null;
};
exports.Product = react_1.default.memo(({ drawingId, isRoot = false, productId, children }) => {
    const rootId = (0, hooks_1.useDrawing)(drawingId, state => state.structure.root);
    const objId = (isRoot && productId === undefined ? rootId : productId) || 0;
    const obj = (0, hooks_1.useDrawing)(drawingId, state => state.structure.tree[objId]);
    if (obj) {
        return (react_1.default.createElement(react_1.default.Fragment, null, isRoot ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(GlobalTransform_1.GlobalTransform, { drawingId: drawingId, objectId: objId },
                react_1.default.createElement(Content, { obj: obj, drawingId: drawingId, children: children })))) : (react_1.default.createElement(geometry_1.Group, { coordinateSystem: obj.coordinateSystem },
            react_1.default.createElement(Content, { obj: obj, drawingId: drawingId, children: children })))));
    }
    return null;
});
function Content({ obj, drawingId, children, }) {
    let content = null;
    if (Array.isArray(obj.solids)) {
        content = react_1.default.createElement(Part, { partId: obj.id, productId: obj.id, drawingId: drawingId });
    }
    else if (typeof obj.link !== 'undefined') {
        content = react_1.default.createElement(Part, { partId: obj.link, productId: obj.id, drawingId: drawingId });
    }
    else if (obj.children) {
        content = obj.children.map(id => react_1.default.createElement(exports.Product, { key: id, productId: id, drawingId: drawingId, children: children }));
    }
    else {
        content = null;
    }
    return children || content ? (react_1.default.createElement("group", { name: obj.name, userData: { id: obj.id } }, children ? children({ node: content, object: obj }) : content)) : null;
}
