"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const button_1 = __importDefault(require("antd/lib/button"));
const tooltip_1 = __importDefault(require("antd/lib/tooltip"));
const react_1 = __importDefault(require("react"));
const styled_components_1 = __importDefault(require("styled-components"));
const BaseButton = (0, styled_components_1.default)(button_1.default) `
  width: 100%;
  margin: 2px 1px;
`;
const IconButton = (0, styled_components_1.default)(button_1.default) `
  width: 25px;
  height: 25px;
  padding: 2px 2px;
  margin: 2px 1px;
`;
const Img = styled_components_1.default.img `
  width: 19px;
  height: 19px;
  margin-bottom: 7px;
  user-drag: none;
  -webkit-user-drag: none;
  user-select: none;
  -moz-user-select: none;
  -webkit-user-select: none;
  -ms-user-select: none;
`;
function Fragment(_a) {
    var props = __rest(_a, []);
    return react_1.default.createElement(react_1.default.Fragment, { key: props.key }, props.children);
}
function Button(_a) {
    var { children, iconSrc, titleText } = _a, props = __rest(_a, ["children", "iconSrc", "titleText"]);
    // Tooltip add redundant span if button is disabled, so there is a workaround: don't render tooltip if button is disabled.
    const Wrapper = titleText ? tooltip_1.default : Fragment;
    return (react_1.default.createElement(Wrapper, { placement: "top", title: titleText },
        !iconSrc && react_1.default.createElement(BaseButton, Object.assign({}, props), children),
        iconSrc && (react_1.default.createElement(IconButton, Object.assign({}, props),
            react_1.default.createElement(Img, { src: iconSrc })))));
}
exports.default = Button;
