"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@buerli.io/core");
const button_1 = __importDefault(require("antd/lib/button"));
const tag_1 = __importDefault(require("antd/lib/tag"));
const react_1 = __importStar(require("react"));
const styled_components_1 = __importDefault(require("styled-components"));
const uuid_1 = require("uuid");
const hooks_1 = require("../../hooks");
const base_1 = __importDefault(require("./base"));
const Base = styled_components_1.default.div `
  ${base_1.default}
  cursor: pointer;
  height: auto !important;
  padding: 0px 8px;
  border: 1px solid #d9d9d9;
  border-radius: 2px;
  background-color: ${props => (props.active ? '#e36b7c' : 'transparent')};
  display: flex;
  flex-direction: column;
  overflow: hidden;
  align-items: center;
  transition: all 0.3s;
  &:hover {
    border-color: #f097a0;
    border-right-width: 1px !important;
  }
`;
const SelectionArea = styled_components_1.default.div `
  cursor: pointer;
  width: 100%;
  padding: 1px 0px;
  height: auto !important;
  background-color: transparent;
  display: flex;
  flex-wrap: wrap;
  overflow: hidden;
  align-items: center;
  .ant-tag {
    margin: 2px;
    min-width: 20px;
    height: 17px;
    line-height: 17px;
    font-weight: bolder;
    display: flex;
    align-items: center;
    justify-content: center;
    padding: 0 3px;
  }
`;
const ModesArea = styled_components_1.default.div `
  cursor: pointer;
  width: 100%;
  height: auto !important;
  border-top: 1px solid white;
  padding: 3px 2px;
  background-color: transparent;
  display: flex;
  flex-wrap: wrap;
  overflow: hidden;
  align-items: center;
`;
const Text = styled_components_1.default.span `
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
  word-break: break-all;
`;
function Selection(_a) {
    var _b;
    var { drawingId, filter = () => true, defaultActive, initialItems = [], maxLen, onChange, onCreated, caption, customSelect, customUnSelect, autoDisable, // Disable selection when itmes.length === maxLen
    modes, onHover } = _a, props = __rest(_a, ["drawingId", "filter", "defaultActive", "initialItems", "maxLen", "onChange", "onCreated", "caption", "customSelect", "customUnSelect", "autoDisable", "modes", "onHover"]);
    const selApi = (0, hooks_1.useDrawing)(drawingId, drawing => drawing.api.selection);
    const [curMode, setCurMode] = react_1.default.useState(modes ? (_b = modes[0]) === null || _b === void 0 ? void 0 : _b.name : '');
    const curModeRef = react_1.default.useRef(curMode); // TODO: this is workaround. It's impossible to change customSelect of created selector. Should be fixed.
    react_1.default.useEffect(() => {
        curModeRef.current = curMode;
    }, [curMode]);
    const customSelect_ = react_1.default.useCallback((selId, items_, diff) => {
        var _a;
        if (modes && modes.length > 0) {
            const mCustomSelect = (_a = modes.find(m => m.name === curModeRef.current)) === null || _a === void 0 ? void 0 : _a.customSelect;
            mCustomSelect ? mCustomSelect(selId, items_, diff) : selApi === null || selApi === void 0 ? void 0 : selApi.setItems(selId, items_);
            return;
        }
        else if (customSelect) {
            customSelect(selId, items_, diff);
            return;
        }
        else {
            selApi === null || selApi === void 0 ? void 0 : selApi.setItems(selId, items_);
        }
    }, [selApi, customSelect, modes]);
    // TODO: remove copypaste?
    const customUnSelect_ = react_1.default.useCallback((selId, items_, diff) => {
        var _a;
        if (modes && modes.length > 0) {
            const mCustomUnSelect = (_a = modes.find(m => m.name === curModeRef.current)) === null || _a === void 0 ? void 0 : _a.customUnSelect;
            mCustomUnSelect ? mCustomUnSelect(selId, items_, diff) : selApi === null || selApi === void 0 ? void 0 : selApi.setItems(selId, items_);
            return;
        }
        else if (customUnSelect) {
            customUnSelect(selId, items_, diff);
            return;
        }
        else {
            selApi === null || selApi === void 0 ? void 0 : selApi.setItems(selId, items_);
        }
    }, [selApi, customUnSelect, modes]);
    const [id] = (0, react_1.useState)(uuid_1.v4);
    (0, react_1.useEffect)(() => {
        const unsub = selApi && selApi.createSelector(id, filter, defaultActive, initialItems, maxLen, customSelect_, customUnSelect_);
        onCreated && onCreated(id);
        return () => unsub && unsub();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const selection = (0, hooks_1.useDrawing)(drawingId, drawing => drawing.selection.refs[id]);
    const activeSelection = (0, hooks_1.useDrawing)(drawingId, drawing => drawing.selection.active);
    const active = activeSelection === id;
    // TODO: fix lint error without disabling it!
    // eslint-disable-next-line react-hooks/exhaustive-deps
    const items = (selection && selection.items) || [];
    (0, react_1.useEffect)(() => {
        const active_ = (0, core_1.getDrawing)(drawingId).selection.active === id;
        if (active_ && autoDisable && items.length === maxLen) {
            (0, core_1.getDrawing)(drawingId).api.selection.activateSelector(null);
        }
    }, [drawingId, id, items, autoDisable, maxLen]);
    // Store current onChange into a reference
    const onChangeRef = (0, react_1.useRef)(onChange);
    (0, react_1.useEffect)(() => void (onChangeRef.current = onChange), [onChange]);
    // On change callback
    (0, react_1.useEffect)(() => {
        if ((selection === null || selection === void 0 ? void 0 : selection.items) && onChangeRef.current)
            onChangeRef.current(selection.items);
    }, [selection === null || selection === void 0 ? void 0 : selection.items]);
    return (react_1.default.createElement(Base, Object.assign({ active: active, onClick: () => selApi && selApi.activateSelector(id) }, props),
        react_1.default.createElement(SelectionArea, null,
            !active && items.length === 0 && (react_1.default.createElement(Text, { style: { lineHeight: '21px', color: '#666' } }, caption || 'Click here to select')),
            active && items.length === 0 && react_1.default.createElement(Text, { style: { lineHeight: '21px', color: 'white' } }, "Select items ..."),
            items.map(item => (react_1.default.createElement(tag_1.default, { key: `${item.id}|${item.scope}`, onClick: active
                    ? (event) => {
                        event.stopPropagation();
                        selApi && selApi.unselect(item, id);
                        onHover && onHover(null);
                    }
                    : undefined, onPointerOver: () => {
                    active && onHover && onHover(item);
                }, onPointerOut: () => {
                    active && onHover && onHover(null);
                } }, item.label ? item.label : item.id.toUpperCase())))),
        active && modes && modes.length > 1 && (react_1.default.createElement(ModesArea, null, modes === null || modes === void 0 ? void 0 : modes.map(mode => {
            return (react_1.default.createElement(button_1.default, { style: {
                    fontSize: '10px',
                    fontWeight: 'bold',
                    height: '16px',
                    padding: '0px 4px',
                    background: curMode === mode.name ? 'white' : 'transparent',
                }, key: mode.name, type: "text", size: "small", onClick: (e) => {
                    setCurMode(mode.name);
                    e.stopPropagation();
                } }, mode.name));
        })))));
}
exports.default = Selection;
