"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Entity = void 0;
const react_1 = __importDefault(require("react"));
const THREE = __importStar(require("three"));
const three_stdlib_1 = require("three-stdlib");
const useDrawing_1 = require("../../../hooks/useDrawing");
const Spline_1 = require("./Spline");
const Entity = props => {
    const { elem, onClick } = props, rest = __rest(props, ["elem", "onClick"]);
    const container = (0, useDrawing_1.useDrawing)(props.drawingId, d => d.geometry.cache[elem.container.id]);
    if (!container) {
        // This case should never happen, but add is as security!
        return null;
    }
    if (container.meshes.length === 0) {
        // If the entity has no meshes, dispaly all lines/edges/arcs
        // This happens for CURVEARRAY's
        return (react_1.default.createElement("group", { onClick: e => onClick === null || onClick === void 0 ? void 0 : onClick([elem], e) },
            container.lines.map(l => (react_1.default.createElement(Spline_1.Spline, Object.assign({}, rest, { key: l.graphicId, elem: Object.assign(Object.assign({}, l), { productId: elem.productId }) })))),
            container.edges.map(l => (react_1.default.createElement(Spline_1.Spline, Object.assign({}, rest, { key: l.graphicId, elem: Object.assign(Object.assign({}, l), { productId: elem.productId }) })))),
            container.arcs.map(l => (react_1.default.createElement(Spline_1.Spline, Object.assign({}, rest, { key: l.graphicId, elem: Object.assign(Object.assign({}, l), { productId: elem.productId }) }))))));
    }
    else {
        return (
        // If the entity has meshes, dispaly meshes
        react_1.default.createElement("group", { onClick: e => onClick === null || onClick === void 0 ? void 0 : onClick([elem], e) },
            react_1.default.createElement(Meshes, Object.assign({ elem: elem, meshes: container.meshes, opacity: 0.6 }, rest))));
    }
};
exports.Entity = Entity;
const Meshes = props => {
    const { elem, meshes, color, opacity, renderOrder } = props;
    const geom = react_1.default.useMemo(() => {
        return (0, three_stdlib_1.mergeBufferGeometries)(meshes.map(i => i.geometry));
    }, [meshes]);
    return (react_1.default.createElement("mesh", { geometry: geom, userData: elem, renderOrder: renderOrder },
        react_1.default.createElement("meshLambertMaterial", { opacity: opacity, color: color, transparent: true, side: THREE.DoubleSide, polygonOffset: true, polygonOffsetFactor: 1, polygonOffsetUnits: 1, toneMapped: false })));
};
