"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Loop = void 0;
const react_1 = __importDefault(require("react"));
const hooks_1 = require("../../../hooks");
const Mesh_1 = require("./Mesh");
const Spline_1 = require("./Spline");
const Loop = props => {
    const { elem, color, opacity, renderOrder, onClick } = props;
    const container = (0, hooks_1.useDrawing)(props.drawingId, d => d.geometry.cache[elem.container.id]);
    const edges = react_1.default.useMemo(() => {
        const result = [];
        const anyElem = elem;
        if (anyElem && anyElem.loops) {
            const loops = anyElem.loops;
            for (const loop of loops) {
                result.push(...loop);
            }
        }
        return result;
    }, [elem]);
    const items = react_1.default.useMemo(() => {
        return container ? edges.map(e => (Object.assign(Object.assign({}, container.map[e]), { productId: elem.productId }))) : [];
    }, [container, edges, elem.productId]);
    return items.length > 0 ? (react_1.default.createElement("group", { renderOrder: renderOrder },
        react_1.default.createElement(Mesh_1.Mesh, { onClick: (mesh, e) => onClick === null || onClick === void 0 ? void 0 : onClick(items, e), key: elem.graphicId, elem: elem, opacity: 0.0 }),
        items.map(item => (react_1.default.createElement(Spline_1.Spline, { key: item.graphicId, elem: item, color: color, opacity: opacity }))))) : null;
};
exports.Loop = Loop;
