"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFeaturePluginDef = void 0;
const react_1 = __importDefault(require("react"));
const __1 = require("../");
function isPromisePlugin(def) {
    return def.then !== undefined;
}
function useFeaturePluginDef(featureClass, callback) {
    const impl = (0, __1.useBuerli)(state => state.options.plugins[featureClass]);
    const [pluginDef] = react_1.default.useState(() => (typeof impl === 'function' ? impl() : impl));
    react_1.default.useEffect(() => {
        if (pluginDef) {
            if (isPromisePlugin(pluginDef)) {
                const promis = pluginDef;
                // eslint-disable-next-line promise/no-callback-in-promise
                promis.then(plugin => callback(plugin)).catch();
            }
            else {
                callback(pluginDef);
            }
        }
        // UseEffect should not happen only if callback is changed
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [pluginDef]);
}
exports.useFeaturePluginDef = useFeaturePluginDef;
