"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePlugin = void 0;
const useDrawing_1 = require("./useDrawing");
/**
 * Hook to select parts of the plugin state.
 *
 * @param drawingId The drawing id.
 * @param pluginId The plugin id.
 * @param sel The selector of the plugin state.
 * @param equalityFn The equality function.
 * @returns The part of the plugin state selected by the selector function (`sel`). Result can be undefined!
 */
function usePlugin(drawingId, pluginId, sel, equalityFn) {
    return (0, useDrawing_1.useDrawing)(drawingId, drawing => {
        if (drawing.plugin.refs[pluginId])
            return sel(drawing.plugin.refs[pluginId]);
    }, equalityFn);
}
exports.usePlugin = usePlugin;
