import React from 'react';
import { PluginWrapperView } from './plugins/PluginWrapperView';
import { usePluginIds } from './plugins/usePluginIds';
import { useBuerli } from '../hooks';
/**
 * Renders the wrappers for all available plugins.
 *
 * Because of performance reasons, this is done in
 * this component and not directly in the canvas!
 */
export const BuerliPluginsGeometry = React.memo(props => {
    const { drawingId, showOnlyActive = true } = props;
    const activeDrawingId = useBuerli(state => state.drawing.active);
    const actualDrawingId = drawingId !== null && drawingId !== void 0 ? drawingId : activeDrawingId;
    const pluginIds = usePluginIds(actualDrawingId);
    return (React.createElement(React.Fragment, null, pluginIds === null || pluginIds === void 0 ? void 0 : pluginIds.map(plugId => (React.createElement(PluginWrapperView, { key: plugId, drawingId: actualDrawingId, pluginId: plugId, showOnlyActive: showOnlyActive })))));
});
