var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import ButtonImpl from 'antd/lib/button';
import Tooltip from 'antd/lib/tooltip';
import React from 'react';
import styled from 'styled-components';
const BaseButton = styled(ButtonImpl) `
  width: 100%;
  margin: 2px 1px;
`;
const IconButton = styled(ButtonImpl) `
  width: 25px;
  height: 25px;
  padding: 2px 2px;
  margin: 2px 1px;
`;
const Img = styled.img `
  width: 19px;
  height: 19px;
  margin-bottom: 7px;
  user-drag: none;
  -webkit-user-drag: none;
  user-select: none;
  -moz-user-select: none;
  -webkit-user-select: none;
  -ms-user-select: none;
`;
function Fragment(_a) {
    var props = __rest(_a, []);
    return React.createElement(React.Fragment, { key: props.key }, props.children);
}
export default function Button(_a) {
    var { children, iconSrc, titleText } = _a, props = __rest(_a, ["children", "iconSrc", "titleText"]);
    // Tooltip add redundant span if button is disabled, so there is a workaround: don't render tooltip if button is disabled.
    const Wrapper = titleText ? Tooltip : Fragment;
    return (React.createElement(Wrapper, { placement: "top", title: titleText },
        !iconSrc && React.createElement(BaseButton, Object.assign({}, props), children),
        iconSrc && (React.createElement(IconButton, Object.assign({}, props),
            React.createElement(Img, { src: iconSrc })))));
}
