import { MathUtils } from '@buerli.io/core';
import React from 'react';
import * as THREE from 'three';
export const Group = ({ name, coordinateSystem, children }) => {
    const matrix = React.useMemo(() => {
        if (coordinateSystem) {
            return MathUtils.convertToMatrix4(coordinateSystem);
        }
        else {
            return new THREE.Matrix4();
        }
    }, [coordinateSystem]);
    return (React.createElement("group", { name: name || '', matrix: matrix, matrixAutoUpdate: false }, children));
};
