var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import * as THREE from 'three';
import { mergeBufferGeometries } from 'three-stdlib';
import { useDrawing } from '../../../hooks/useDrawing';
import { Spline } from './Spline';
export const Entity = props => {
    const { elem, onClick } = props, rest = __rest(props, ["elem", "onClick"]);
    const container = useDrawing(props.drawingId, d => d.geometry.cache[elem.container.id]);
    if (!container) {
        // This case should never happen, but add is as security!
        return null;
    }
    if (container.meshes.length === 0) {
        // If the entity has no meshes, dispaly all lines/edges/arcs
        // This happens for CURVEARRAY's
        return (React.createElement("group", { onClick: e => onClick === null || onClick === void 0 ? void 0 : onClick([elem], e) },
            container.lines.map(l => (React.createElement(Spline, Object.assign({}, rest, { key: l.graphicId, elem: Object.assign(Object.assign({}, l), { productId: elem.productId }) })))),
            container.edges.map(l => (React.createElement(Spline, Object.assign({}, rest, { key: l.graphicId, elem: Object.assign(Object.assign({}, l), { productId: elem.productId }) })))),
            container.arcs.map(l => (React.createElement(Spline, Object.assign({}, rest, { key: l.graphicId, elem: Object.assign(Object.assign({}, l), { productId: elem.productId }) }))))));
    }
    else {
        return (
        // If the entity has meshes, dispaly meshes
        React.createElement("group", { onClick: e => onClick === null || onClick === void 0 ? void 0 : onClick([elem], e) },
            React.createElement(Meshes, Object.assign({ elem: elem, meshes: container.meshes, opacity: 0.6 }, rest))));
    }
};
const Meshes = props => {
    const { elem, meshes, color, opacity, renderOrder } = props;
    const geom = React.useMemo(() => {
        return mergeBufferGeometries(meshes.map(i => i.geometry));
    }, [meshes]);
    return (React.createElement("mesh", { geometry: geom, userData: elem, renderOrder: renderOrder },
        React.createElement("meshLambertMaterial", { opacity: opacity, color: color, transparent: true, side: THREE.DoubleSide, polygonOffset: true, polygonOffsetFactor: 1, polygonOffsetUnits: 1, toneMapped: false })));
};
