import React from 'react';
import { useDrawing } from '../../../hooks';
import { Mesh } from './Mesh';
import { Spline } from './Spline';
export const Loop = props => {
    const { elem, color, opacity, renderOrder, onClick } = props;
    const container = useDrawing(props.drawingId, d => d.geometry.cache[elem.container.id]);
    const edges = React.useMemo(() => {
        const result = [];
        const anyElem = elem;
        if (anyElem && anyElem.loops) {
            const loops = anyElem.loops;
            for (const loop of loops) {
                result.push(...loop);
            }
        }
        return result;
    }, [elem]);
    const items = React.useMemo(() => {
        return container ? edges.map(e => (Object.assign(Object.assign({}, container.map[e]), { productId: elem.productId }))) : [];
    }, [container, edges, elem.productId]);
    return items.length > 0 ? (React.createElement("group", { renderOrder: renderOrder },
        React.createElement(Mesh, { onClick: (mesh, e) => onClick === null || onClick === void 0 ? void 0 : onClick(items, e), key: elem.graphicId, elem: elem, opacity: 0.0 }),
        items.map(item => (React.createElement(Spline, { key: item.graphicId, elem: item, color: color, opacity: opacity }))))) : null;
};
