import { extend, useThree } from '@react-three/fiber';
import React from 'react';
import * as THREE from 'three';
import { Line2 } from 'three/examples/jsm/lines/Line2';
import { LineGeometry as LG } from 'three/examples/jsm/lines/LineGeometry';
import { LineMaterial } from 'three/examples/jsm/lines/LineMaterial';
extend({ Line2, LineMaterial });
export const Spline = props => {
    const { elem, color = 'black', renderOrder = 1, opacity = 1, lineWidth = 6.0, onClick } = props;
    const { size } = useThree();
    const resolution = React.useMemo(() => new THREE.Vector2(size.width, size.height), [size]);
    const lg = React.useMemo(() => {
        const primitive = elem.geometry;
        return new LG().setPositions(primitive.attributes.position.array);
    }, [elem.geometry]);
    return (React.createElement("line2", { onClick: e => onClick === null || onClick === void 0 ? void 0 : onClick([elem], e), geometry: lg, userData: elem, renderOrder: renderOrder },
        React.createElement("lineMaterial", { color: color, opacity: opacity, linewidth: lineWidth, dashed: false, resolution: resolution, transparent: true, alphaTest: 0.0, depthWrite: false, depthTest: false, polygonOffset: true, polygonOffsetFactor: 1, polygonOffsetUnits: 1, toneMapped: false })));
};
