import React from 'react';
import { useBuerli } from '../';
function isPromisePlugin(def) {
    return def.then !== undefined;
}
export function useFeaturePluginDef(featureClass, callback) {
    const impl = useBuerli(state => state.options.plugins[featureClass]);
    const [pluginDef] = React.useState(() => (typeof impl === 'function' ? impl() : impl));
    React.useEffect(() => {
        if (pluginDef) {
            if (isPromisePlugin(pluginDef)) {
                const promis = pluginDef;
                // eslint-disable-next-line promise/no-callback-in-promise
                promis.then(plugin => callback(plugin)).catch();
            }
            else {
                callback(pluginDef);
            }
        }
        // UseEffect should not happen only if callback is changed
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [pluginDef]);
}
