import { useDrawing } from './useDrawing';
/**
 * Hook to select parts of the plugin state.
 *
 * @param drawingId The drawing id.
 * @param pluginId The plugin id.
 * @param sel The selector of the plugin state.
 * @param equalityFn The equality function.
 * @returns The part of the plugin state selected by the selector function (`sel`). Result can be undefined!
 */
export function usePlugin(drawingId, pluginId, sel, equalityFn) {
    return useDrawing(drawingId, drawing => {
        if (drawing.plugin.refs[pluginId])
            return sel(drawing.plugin.refs[pluginId]);
    }, equalityFn);
}
