import { DrawingID, DrawingState } from '@buerli.io/core';
/**
 * Hook to select parts of the drawing state.
 *
 * @param id The drawing id.
 * @param sel The selector of the drawing state.
 * @param equalityFn The equality function.
 * @returns The part of the drawing state selected by the selector function (`sel`). Result can be undefined!
 */
export declare function useDrawing<T>(id: DrawingID, sel: (state: DrawingState) => T | undefined, equalityFn?: ((a: T | undefined, b: T | undefined) => boolean) | undefined): T | undefined;
