import { DrawingID, PluginID, PluginState } from '@buerli.io/core';
/**
 * Hook to select parts of the plugin state.
 *
 * @param drawingId The drawing id.
 * @param pluginId The plugin id.
 * @param sel The selector of the plugin state.
 * @param equalityFn The equality function.
 * @returns The part of the plugin state selected by the selector function (`sel`). Result can be undefined!
 */
export declare function usePlugin<T>(drawingId: DrawingID, pluginId: PluginID, sel: (state: PluginState) => T | undefined, equalityFn?: ((a: T | undefined, b: T | undefined) => boolean) | undefined): T | undefined;
