/// <reference types="react" />
import { BuerliGeometry } from './components/BuerliGeometry';
import { BuerliGeometryInteraction } from './components/BuerliGeometryInteraction';
import { BuerliPluginsGeometry } from './components/BuerliPluginsGeometry';
import Overlay from './components/geometry/overlay';
import Alert from './components/elements/Alert';
import AutoComplete from './components/elements/AutoComplete';
import Button from './components/elements/Button';
import ButtonGroup from './components/elements/ButtonGroup';
import Checkbox from './components/elements/Checkbox';
import Collapse from './components/elements/Collapse';
import Dropdown from './components/elements/Dropdown';
import Group from './components/elements/Group';
import { Menu, MenuItem } from './components/elements/Menu';
import Selection from './components/elements/Selection';
import Slider from './components/elements/Slider';
import { TabPane, Tabs } from './components/elements/Tabs';
import Tooltip from './components/elements/Tooltip';
import Plugin from './components/Plugin';
import { PluginManager } from './components/plugins/PluginManager';
import Messenger from './components/ui/Messenger';
import { findBuerliGeometry } from './helpers/findBuerliGeometry';
export declare const elements: {
    Group: typeof Group;
    Button: typeof Button;
    ButtonGroup: typeof ButtonGroup;
    Input: import("react").ForwardRefExoticComponent<import("antd/lib/input").InputProps & import("react").RefAttributes<import("rc-input").InputRef>>;
    Label: import("styled-components").StyledComponent<"div", any, {
        highlighted?: boolean | undefined;
        bold?: boolean | undefined;
        ellipsis?: boolean | undefined;
    }, never>;
    Select: import("react").ForwardRefExoticComponent<{
        children?: any[] | undefined;
    } & import("antd/lib/select").SelectProps<any, import("rc-select/lib/Select").DefaultOptionType> & import("react").RefAttributes<import("rc-select").BaseSelectRef>>;
    Mentions: import("react").ForwardRefExoticComponent<import("antd/lib/mentions").MentionProps & import("react").RefAttributes<any>> & {
        Option: import("react").FC<import("rc-mentions/lib/Option").OptionProps>;
    };
    Slider: typeof Slider;
    Checkbox: typeof Checkbox;
    Collapse: typeof Collapse;
    Selection: typeof Selection;
    AutoComplete: typeof AutoComplete;
    Alert: typeof Alert;
    Tabs: typeof Tabs;
    TabPane: typeof TabPane;
    Tooltip: typeof Tooltip;
    Menu: typeof Menu;
    MenuItem: typeof MenuItem;
    Dropdown: typeof Dropdown;
};
export * from './components/GlobalTransform';
export * from './helpers/CameraHelper';
export * from './headless';
export * from './hooks';
export * from './types/three-fiber';
export { BuerliPluginsGeometry, BuerliGeometry, BuerliGeometryInteraction, Overlay, findBuerliGeometry, Plugin, Messenger, PluginManager, };
export declare type ReactElements = typeof elements;
